Option Explicit On 
Option Strict On
Option Compare Binary

Imports System.Collections

' <remarks>
'   Implementiert einen Vergleicher.
' </remarks>
Public Class ValueComparer
    Implements IComparer

    ' <summary>
    '   Fhrt einen Vergleich der Objekte in den Parametern 
    '   <paramref name="x"/> und <paramref name="y"/>.
    ' </summary>
    ' <param name="x">Das erste der beiden zu vergleichenden Objekte.</param>
    ' <param name="y">Das zweite der beiden zu vergleichenden Objekte.</param>
    ' <returns>
    '   < 0      x ist kleiner als y.
    '   = 0      x ist gleich y.
    '   > 0      x ist grsser als y.
    ' </returns>
    Public Function Compare( _
      ByVal x As Object, _
      ByVal y As Object) _
      As Integer Implements IComparer.Compare
        Dim el1 As Element = DirectCast(x, Element)
        Dim el2 As Element = DirectCast(y, Element)
        Return CInt((el1.Cost / el1.Weight) - (el2.Cost / el2.Weight))
    End Function
End Class